- [HTTP request](https://docs.cloud.google.com/memorystore/docs/valkey/reference/rest/v1alpha/projects.locations.instances/list#body.HTTP_TEMPLATE)
- [Path parameters](https://docs.cloud.google.com/memorystore/docs/valkey/reference/rest/v1alpha/projects.locations.instances/list#body.PATH_PARAMETERS)
- [Query parameters](https://docs.cloud.google.com/memorystore/docs/valkey/reference/rest/v1alpha/projects.locations.instances/list#body.QUERY_PARAMETERS)
- [Request body](https://docs.cloud.google.com/memorystore/docs/valkey/reference/rest/v1alpha/projects.locations.instances/list#body.request_body)
- [Response body](https://docs.cloud.google.com/memorystore/docs/valkey/reference/rest/v1alpha/projects.locations.instances/list#body.response_body)
  - [JSON representation](https://docs.cloud.google.com/memorystore/docs/valkey/reference/rest/v1alpha/projects.locations.instances/list#body.ListInstancesResponse.SCHEMA_REPRESENTATION)
- [Authorization scopes](https://docs.cloud.google.com/memorystore/docs/valkey/reference/rest/v1alpha/projects.locations.instances/list#body.aspect)
- [IAM Permissions](https://docs.cloud.google.com/memorystore/docs/valkey/reference/rest/v1alpha/projects.locations.instances/list#body.aspect_1)

Lists Instances in a given project and location.

### HTTP request

Choose an endpoint:
global africa-south1 asia-east1 asia-east2 asia-northeast1 asia-northeast2 asia-northeast3 asia-south1 asia-south2 asia-southeast1 asia-southeast2 asia-southeast3 australia-southeast1 australia-southeast2 europe-central2 europe-north1 europe-north2 europe-southwest1 europe-west1 europe-west10 europe-west12 europe-west15 europe-west2 europe-west3 europe-west4 europe-west6 europe-west8 europe-west9 me-central1 me-central2 me-west1 northamerica-northeast1 northamerica-northeast2 northamerica-south1 southamerica-east1 southamerica-west1 us-central1 us-central2 us-east1 us-east4 us-east5 us-east7 us-south1 us-west1 us-west2 us-west3 us-west4 us-west8   
`GET https://memorystore.googleapis.com/v1alpha/{parent=projects/*/locations/*}/instances`

<br />

The URLs use [gRPC Transcoding](https://google.aip.dev/127) syntax.

### Path parameters

| Parameters ||
|---|---|
| `parent` | `string` Required. The parent to list instances from. Format: projects/{project}/locations/{location} |

### Query parameters

| Parameters ||
|---|---|
| `pageSize` | `integer` Optional. Requested page size. Server may return fewer items than requested. If unspecified, server will pick an appropriate default. |
| `pageToken` | `string` Optional. A token identifying a page of results the server should return. |
| `filter` | `string` Optional. Expression for filtering results. |
| `orderBy` | `string` Optional. Sort results by a defined order. Supported values: "name", "createTime". |

### Request body

The request body must be empty.

### Response body

Response message for `instances.list`.

If successful, the response body contains data with the following structure:

| JSON representation |
|---|
| ``` { "instances": [ { object (`https://docs.cloud.google.com/memorystore/docs/valkey/reference/rest/v1alpha/projects.locations.instances#Instance`) } ], "nextPageToken": string, "unreachable": [ string ] } ``` |

| Fields ||
|---|---|
| `instances[]` | ``object (`https://docs.cloud.google.com/memorystore/docs/valkey/reference/rest/v1alpha/projects.locations.instances#Instance`)`` If the {location} requested was "-" the response contains a list of instances from all locations. Instances in unreachable locations will be omitted. |
| `nextPageToken` | `string` A token, which can be sent as `pageToken` to retrieve the next page. If this field is omitted, there are no subsequent pages. |
| `unreachable[]` | `string` Locations that could not be reached. |

### Authorization scopes

Requires one of the following OAuth scopes:

- `https://www.googleapis.com/auth/cloud-platform`
- `https://www.googleapis.com/auth/memorystore.read-write`
- `https://www.googleapis.com/auth/memorystore.read-only`

### IAM Permissions

Requires the following [IAM](https://cloud.google.com/iam/docs) permission on the `parent` resource:

- `memorystore.instances.list`

For more information, see the [IAM documentation](https://cloud.google.com/iam/docs).